REM https://github.com/facebook/zstd/archive/v1.3.2.tar.gz

set P=zstd
set V=1.3.2
set B=1

set ARCH=%1

if "%ARCH%"=="x86_64" (
	set OSGEO4W_ROOT=C:\OSGeo4W64
	set CMAKEGEN=Visual Studio 14 2015 Win64
	set VCARCH=x64
) else if "%ARCH%"=="x86" (
	set OSGEO4W_ROOT=C:\OSGeo4W
	set CMAKEGEN=Visual Studio 14 2015
	set VCARCH=x86
) else (
	echo "unsupported arch %ARCH%"
	goto error
)

set R=..\..\..\%ARCH%\release\%P%

mkdir %R%
for %%i in (bin devel) do (
	mkdir %R%\%P%-%%i
)

call "C:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" %VCARCH%
echo on
path C:\Program Files\CMake\bin;C:\Program Files (x86)\Microsoft Visual Studio 14.0\Common7\IDE;%PATH%

mkdir build-%ARCH%
cd build-%ARCH%

cmake -G "%CMAKEGEN%" ^
	-D CMAKE_INSTALL_PREFIX=..\install-%ARCH% ^
	..\..\build\cmake
if errorlevel 1 (echo cmake error & goto error)

cd ..

for %%i in (ZERO_CHECK ALL_BUILD INSTALL) do (
        echo %%i: %DATE% %TIME%
        cmake --build build-%ARCH% --target %%i --config Release
        if errorlevel 1 (echo %%i error & goto error)
)

copy dll.hint %R%\setup.hint
copy ..\LICENSE %R%\%P%-%V%-%B%.txt

copy dev.hint %R%\%P%-devel\setup.hint
copy ..\LICENSE %R%\%P%-devel\%P%-devel-%V%-%B%.txt

copy bin.hint %R%\%P%-bin\setup.hint
copy ..\LICENSE %R%\%P%-bin\%P%-bin-%V%-%B%.txt

tar -C .. -cjf %R%\%P%-%V%-%B%-src.tar.bz2 ^
	osgeo4w/dev.hint ^
	osgeo4w/dll.hint ^
	osgeo4w/bin.hint ^
	osgeo4w/package.cmd
if errorlevel 1 (echo tar src & goto error)

tar -C install-%ARCH% -cjf %R%\%P%-%V%-%B%.tar.bz2 ^
	bin/zstd.dll
if errorlevel 1 (echo tar main & goto error)

tar -C install-%ARCH% -cjf %R%\%P%-bin\%P%-bin-%V%-%B%.tar.bz2 ^
	--exclude bin/zstd.dll ^
	bin
if errorlevel 1 (echo tar bin & goto error)

tar -C install-%ARCH% -cjf %R%\%P%-devel\%P%-devel-%V%-%B%.tar.bz2 ^
	lib ^
	include
if errorlevel 1 (echo tar devel & goto error)

goto ok

:error
exit /b 1

:ok
